libstdc++: __gnu_cxx::stdio_filebuf< _CharT, _Traits > Class Template Reference

libstdc++

__gnu_cxx::stdio_filebuf< _CharT, _Traits > Class Template Reference
I/O

`#include <stdio_filebuf.h>`

Inheritance diagram for __gnu_cxx::stdio_filebuf< _CharT, _Traits >:
[legend]

## Public Types
typedef codecvt< char_type, char, __state_type > | __codecvt_type
typedef __basic_file< char > | __file_type
typedef basic_filebuf< char_type, traits_type > | __filebuf_type
typedef traits_type::state_type | __state_type
typedef basic_streambuf< char_type, traits_type > | __streambuf_type
typedef _CharT | char_type
typedef traits_type::int_type | int_type
typedef traits_type::off_type | off_type
typedef traits_type::pos_type | pos_type
typedef std::size_t | size_t
typedef _Traits | traits_type

## Public Member Functions
| stdio_filebuf ()
| stdio_filebuf (int __fd, std::ios_base::openmode __mode, size_t __size=static_cast< size_t >(BUFSIZ))
| stdio_filebuf (std::__c_file *__f, std::ios_base::openmode __mode, size_t __size=static_cast< size_t >(BUFSIZ))
| stdio_filebuf (stdio_filebuf &&)=default
virtual | ~stdio_filebuf ()
__filebuf_type * | close ()
int | fd ()
std::__c_file * | file ()
locale | getloc () const
streamsize | in_avail ()
bool | is_open () const throw ()
template<typename _Path>
_If_fs_path< _Path, __filebuf_type * > | open (const _Path &__s, ios_base::openmode __mode)
__filebuf_type * | open (const char *__s, ios_base::openmode __mode)
__filebuf_type * | open (const std::string &__s, ios_base::openmode __mode)
stdio_filebuf & | operator= (stdio_filebuf &&)=default
locale | pubimbue (const locale &__loc)
int_type | sbumpc ()
int_type | sgetc ()
streamsize | sgetn (char_type *__s, streamsize __n)
int_type | snextc ()
int_type | sputbackc (char_type __c)
int_type | sputc (char_type __c)
streamsize | sputn (const char_type *__s, streamsize __n)
int_type | sungetc ()
void | swap (stdio_filebuf &__fb)
void | swap (basic_filebuf &)
basic_streambuf * | pubsetbuf (char_type *__s, streamsize __n)
pos_type | pubseekoff (off_type __off, ios_base::seekdir __way, ios_base::openmode __mode=ios_base::in|ios_base::out)
pos_type | pubseekpos (pos_type __sp, ios_base::openmode __mode=ios_base::in|ios_base::out)
int | pubsync ()

## Protected Member Functions
void | __safe_gbump (streamsize __n)
void | __safe_pbump (streamsize __n)
void | _M_allocate_internal_buffer ()
bool | _M_convert_to_external (char_type *, streamsize)
void | _M_create_pback ()
void | _M_destroy_internal_buffer () throw ()
void | _M_destroy_pback () throw ()
int | _M_get_ext_pos (__state_type &__state)
pos_type | _M_seek (off_type __off, ios_base::seekdir __way, __state_type __state)
void | _M_set_buffer (streamsize __off)
bool | _M_terminate_output ()
void | gbump (int __n)
virtual void | imbue (const locale &__loc)
virtual int_type | overflow (int_type __c=_Traits::eof())
virtual int_type | pbackfail (int_type __c=_Traits::eof())
void | pbump (int __n)
virtual pos_type | seekoff (off_type __off, ios_base::seekdir __way, ios_base::openmode __mode=ios_base::in|ios_base::out)
virtual pos_type | seekpos (pos_type __pos, ios_base::openmode __mode=ios_base::in|ios_base::out)
virtual __streambuf_type * | setbuf (char_type *__s, streamsize __n)
void | setg (char_type *__gbeg, char_type *__gnext, char_type *__gend)
void | setp (char_type *__pbeg, char_type *__pend)
virtual streamsize | showmanyc ()
void | swap (basic_streambuf &__sb)
virtual int | sync ()
virtual int_type | uflow ()
virtual int_type | underflow ()
virtual streamsize | xsgetn (char_type *__s, streamsize __n)
virtual streamsize | xsputn (const char_type *__s, streamsize __n)
char_type * | eback () const
char_type * | gptr () const
char_type * | egptr () const
char_type * | pbase () const
char_type * | pptr () const
char_type * | epptr () const

## Protected Attributes
char_type * | _M_buf
bool | _M_buf_allocated
locale | _M_buf_locale
size_t | _M_buf_size
const __codecvt_type * | _M_codecvt
char * | _M_ext_buf
streamsize | _M_ext_buf_size
char * | _M_ext_end
const char * | _M_ext_next
__file_type | _M_file
char_type * | _M_in_beg
char_type * | _M_in_cur
char_type * | _M_in_end
__c_lock | _M_lock
ios_base::openmode | _M_mode
char_type * | _M_out_beg
char_type * | _M_out_cur
char_type * | _M_out_end
bool | _M_reading
__state_type | _M_state_beg
__state_type | _M_state_cur
__state_type | _M_state_last
bool | _M_writing
char_type | _M_pback
char_type * | _M_pback_cur_save
char_type * | _M_pback_end_save
bool | _M_pback_init

## Detailed Description

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>
class __gnu_cxx::stdio_filebuf< _CharT, _Traits >

Provides a layer of compatibility for C/POSIX.

This GNU extension provides extensions for working with standard C FILE*'s and POSIX file descriptors. It must be instantiated by the user with the type of character used in the file stream, e.g., stdio_filebuf<char>.

Definition at line 54 of file stdio_filebuf.h.

## Member Typedef Documentation

## ◆ __codecvt_type

template<typename _CharT, typename _Traits>

typedef codecvt<char_type, char, __state_type> std::basic_filebuf< _CharT, _Traits >::__codecvt_type
| inherited

Definition at line 120 of file fstream.

## ◆ __file_type

template<typename _CharT, typename _Traits>

typedef __basic_file<char> std::basic_filebuf< _CharT, _Traits >::__file_type
| inherited

Definition at line 118 of file fstream.

## ◆ __filebuf_type

template<typename _CharT, typename _Traits>

typedef basic_filebuf<char_type, traits_type> std::basic_filebuf< _CharT, _Traits >::__filebuf_type
| inherited

Definition at line 117 of file fstream.

## ◆ __state_type

template<typename _CharT, typename _Traits>

typedef traits_type::state_type std::basic_filebuf< _CharT, _Traits >::__state_type
| inherited

Definition at line 119 of file fstream.

## ◆ __streambuf_type

template<typename _CharT, typename _Traits>

typedef basic_streambuf<char_type, traits_type> std::basic_filebuf< _CharT, _Traits >::__streambuf_type
| inherited

Definition at line 116 of file fstream.

## ◆ char_type

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

typedef _CharT __gnu_cxx::stdio_filebuf< _CharT, _Traits >::char_type

Definition at line 58 of file stdio_filebuf.h.

## ◆ int_type

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

typedef traits_type::int_type __gnu_cxx::stdio_filebuf< _CharT, _Traits >::int_type

Definition at line 60 of file stdio_filebuf.h.

## ◆ off_type

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

typedef traits_type::off_type __gnu_cxx::stdio_filebuf< _CharT, _Traits >::off_type

Definition at line 62 of file stdio_filebuf.h.

## ◆ pos_type

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

typedef traits_type::pos_type __gnu_cxx::stdio_filebuf< _CharT, _Traits >::pos_type

Definition at line 61 of file stdio_filebuf.h.

## ◆ size_t

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

typedef std::size_t __gnu_cxx::stdio_filebuf< _CharT, _Traits >::size_t

Definition at line 63 of file stdio_filebuf.h.

## ◆ traits_type

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

typedef _Traits __gnu_cxx::stdio_filebuf< _CharT, _Traits >::traits_type

Definition at line 59 of file stdio_filebuf.h.

## Constructor & Destructor Documentation

## ◆ stdio_filebuf() [1/3]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

__gnu_cxx::stdio_filebuf< _CharT, _Traits >::stdio_filebuf | ( |  | ) |
| inline

deferred initialization

Definition at line 69 of file stdio_filebuf.h.

References std::basic_filebuf< _CharT, _Traits >::basic_filebuf().

## ◆ stdio_filebuf() [2/3]

template<typename _CharT, typename _Traits>

__gnu_cxx::stdio_filebuf< _CharT, _Traits >::stdio_filebuf | ( | int | __fd,
|  | std::ios_base::openmode | __mode,
|  | size_t | __size = static_cast<size_t>( BUFSIZ ) )

Parameters

  __fd | An open file descriptor.
  __mode | Same meaning as in a standard filebuf.
  __size | Optimal or preferred size of internal buffer, in chars.

This constructor associates a file stream buffer with an open POSIX file descriptor. The file descriptor will be automatically closed when the stdio_filebuf is closed/destroyed.

Definition at line 140 of file stdio_filebuf.h.

References std::basic_filebuf< _CharT, _Traits >::_M_buf_size, std::basic_filebuf< _CharT, _Traits >::_M_mode, std::basic_filebuf< _CharT, _Traits >::_M_reading, std::basic_filebuf< _CharT, _Traits >::_M_set_buffer(), and std::basic_filebuf< _CharT, _Traits >::is_open().

## ◆ stdio_filebuf() [3/3]

template<typename _CharT, typename _Traits>

__gnu_cxx::stdio_filebuf< _CharT, _Traits >::stdio_filebuf | ( | std::__c_file * | __f,
|  | std::ios_base::openmode | __mode,
|  | size_t | __size = static_cast<size_t>( BUFSIZ ) )

Parameters

  __f | An open `FILE*`.
  __mode | Same meaning as in a standard filebuf.
  __size | Optimal or preferred size of internal buffer, in chars. Defaults to system's `BUFSIZ`.

This constructor associates a file stream buffer with an open C `FILE*`. The `FILE*` will not be automatically closed when the stdio_filebuf is closed/destroyed.

Definition at line 156 of file stdio_filebuf.h.

References std::basic_filebuf< _CharT, _Traits >::_M_buf_size, std::basic_filebuf< _CharT, _Traits >::_M_mode, std::basic_filebuf< _CharT, _Traits >::_M_reading, std::basic_filebuf< _CharT, _Traits >::_M_set_buffer(), and std::basic_filebuf< _CharT, _Traits >::is_open().

## ◆ ~stdio_filebuf()

template<typename _CharT, typename _Traits>

__gnu_cxx::stdio_filebuf< _CharT, _Traits >::~stdio_filebuf | ( |  | ) |
| virtual

Closes the external data stream if the file descriptor constructor was used.

Definition at line 136 of file stdio_filebuf.h.

## Member Function Documentation

## ◆ __safe_gbump()

template<typename _CharT, typename _Traits>

void std::basic_streambuf< _CharT, _Traits >::__safe_gbump | ( | streamsize | __n | ) |
| inlineprotectedinherited

Definition at line 804 of file streambuf.

## ◆ __safe_pbump()

template<typename _CharT, typename _Traits>

void std::basic_streambuf< _CharT, _Traits >::__safe_pbump | ( | streamsize | __n | ) |
| inlineprotectedinherited

Definition at line 807 of file streambuf.

## ◆ _M_allocate_internal_buffer()

template<typename _CharT, typename _Traits>

void std::basic_filebuf< _CharT, _Traits >::_M_allocate_internal_buffer | ( |  | ) |
| protectedinherited

Definition at line 54 of file fstream.tcc.

## ◆ _M_convert_to_external()

template<typename _CharT, typename _Traits>

bool std::basic_filebuf< _CharT, _Traits >::_M_convert_to_external | ( | char_type * | __ibuf,
|  | streamsize | __ilen )
| protectedinherited

Definition at line 610 of file fstream.tcc.

## ◆ _M_create_pback()

template<typename _CharT, typename _Traits>

void std::basic_filebuf< _CharT, _Traits >::_M_create_pback | ( |  | ) |
| inlineprotectedinherited

Initializes pback buffers, and moves normal buffers to safety. Assumptions: _M_in_cur has already been moved back

Definition at line 211 of file fstream.

Referenced by pbackfail().

## ◆ _M_destroy_internal_buffer()

template<typename _CharT, typename _Traits>

void std::basic_filebuf< _CharT, _Traits >::_M_destroy_internal_buffer | ( |  | ) |
throw | ( | ) |  |  |
| protectedinherited

Definition at line 68 of file fstream.tcc.

## ◆ _M_destroy_pback()

template<typename _CharT, typename _Traits>

void std::basic_filebuf< _CharT, _Traits >::_M_destroy_pback | ( |  | ) |
throw | ( | ) |  |  |
| inlineprotectedinherited

Deactivates pback buffer contents, and restores normal buffer. Assumptions: The pback buffer has only moved forward.

Definition at line 228 of file fstream.

Referenced by overflow(), seekoff(), seekpos(), underflow(), and xsgetn().

## ◆ _M_get_ext_pos()

template<typename _CharT, typename _Traits>

int std::basic_filebuf< _CharT, _Traits >::_M_get_ext_pos | ( | __state_type & | __state | ) |
| protectedinherited

Definition at line 933 of file fstream.tcc.

## ◆ _M_seek()

template<typename _CharT, typename _Traits>

basic_filebuf< _CharT, _Traits >::pos_type std::basic_filebuf< _CharT, _Traits >::_M_seek | ( | off_type | __off,
|  | ios_base::seekdir | __way,
|  | __state_type | __state )
| protectedinherited

Definition at line 908 of file fstream.tcc.

## ◆ _M_set_buffer()

template<typename _CharT, typename _Traits>

void std::basic_filebuf< _CharT, _Traits >::_M_set_buffer | ( | streamsize | __off | ) |
| inlineprotectedinherited

This function sets the pointers of the internal buffer, both get and put areas. Typically:

__off == egptr() - eback() upon underflow/uflow (read mode); __off == 0 upon overflow (write mode); __off == -1 upon open, setbuf, seekoff/pos (uncommitted mode).

NB: epptr() - pbase() == _M_buf_size - 1, since _M_buf_size reflects the actual allocated memory and the last cell is reserved for the overflow char of a full put area.

Definition at line 502 of file fstream.

Referenced by __gnu_cxx::stdio_filebuf< _CharT, _Traits >::stdio_filebuf(), __gnu_cxx::stdio_filebuf< _CharT, _Traits >::stdio_filebuf(), close(), imbue(), open(), overflow(), pbackfail(), underflow(), xsgetn(), and xsputn().

## ◆ _M_terminate_output()

template<typename _CharT, typename _Traits>

bool std::basic_filebuf< _CharT, _Traits >::_M_terminate_output | ( |  | ) |
| protectedinherited

Definition at line 952 of file fstream.tcc.

## ◆ close()

template<typename _CharT, typename _Traits>

basic_filebuf< _CharT, _Traits >::__filebuf_type * std::basic_filebuf< _CharT, _Traits >::close | ( |  | ) |
| inherited

Closes the currently associated file.

Returns
  `this` on success, NULL on failure

If no file is currently open, this function immediately fails.

If a put buffer area exists, `overflow(eof)` is called to flush all the characters. The file is then closed.

If any operations fail, this function also fails.

Definition at line 253 of file fstream.tcc.

References basic_filebuf(), _M_mode, _M_pback_init, _M_reading, _M_set_buffer(), and is_open().

Referenced by std::basic_filebuf< char_type, traits_type >::~basic_filebuf(), and open().

## ◆ eback()

template<typename _CharT, typename _Traits>

char_type * std::basic_streambuf< _CharT, _Traits >::eback | ( |  | ) | const
| inlineprotectedinherited

Access to the get area.

These functions are only available to other protected functions, including derived classes.

- eback() returns the beginning pointer for the input sequence
- gptr() returns the next pointer for the input sequence
- egptr() returns the end pointer for the input sequence

Definition at line 491 of file streambuf.

Referenced by std::basic_filebuf< char_type, traits_type >::_M_destroy_pback(), std::basic_filebuf< _CharT, _Traits >::imbue(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_filebuf< _CharT, _Traits >::pbackfail(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::pbackfail(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), std::basic_streambuf< char_type, traits_type >::sputbackc(), std::basic_streambuf< char_type, traits_type >::sungetc(), std::basic_filebuf< _CharT, _Traits >::underflow(), and std::basic_filebuf< _CharT, _Traits >::xsgetn().

## ◆ egptr()

template<typename _CharT, typename _Traits>

char_type * std::basic_streambuf< _CharT, _Traits >::egptr | ( |  | ) | const
| inlineprotectedinherited

Access to the get area.

These functions are only available to other protected functions, including derived classes.

- eback() returns the beginning pointer for the input sequence
- gptr() returns the next pointer for the input sequence
- egptr() returns the end pointer for the input sequence

Definition at line 497 of file streambuf.

Referenced by std::basic_filebuf< char_type, traits_type >::_M_create_pback(), std::basic_streambuf< char_type, traits_type >::in_avail(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_streambuf< char_type, traits_type >::sbumpc(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), std::basic_streambuf< char_type, traits_type >::sgetc(), std::basic_filebuf< _CharT, _Traits >::showmanyc(), std::basic_stringbuf< char >::showmanyc(), std::basic_filebuf< _CharT, _Traits >::underflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::underflow(), std::wbuffer_convert< _Codecvt, _Elem, _Tr >::underflow(), std::basic_filebuf< _CharT, _Traits >::xsgetn(), and xsgetn().

## ◆ epptr()

template<typename _CharT, typename _Traits>

char_type * std::basic_streambuf< _CharT, _Traits >::epptr | ( |  | ) | const
| inlineprotectedinherited

Access to the put area.

These functions are only available to other protected functions, including derived classes.

- pbase() returns the beginning pointer for the output sequence
- pptr() returns the next pointer for the output sequence
- epptr() returns the end pointer for the output sequence

Definition at line 544 of file streambuf.

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), std::basic_streambuf< char_type, traits_type >::sputc(), std::basic_filebuf< _CharT, _Traits >::xsputn(), and xsputn().

## ◆ fd()

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

int __gnu_cxx::stdio_filebuf< _CharT, _Traits >::fd | ( |  | ) |
| inline

Returns
  The underlying file descriptor.

Once associated with an external data stream, this function can be used to access the underlying POSIX file descriptor. Note that there is no way for the library to track what you do with the descriptor, so be careful.

Definition at line 122 of file stdio_filebuf.h.

## ◆ file()

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

std::__c_file * __gnu_cxx::stdio_filebuf< _CharT, _Traits >::file | ( |  | ) |
| inline

Returns
  The underlying FILE*.

This function can be used to access the underlying "C" file pointer. Note that there is no way for the library to track what you do with the file, so be careful.

Definition at line 132 of file stdio_filebuf.h.

## ◆ gbump()

template<typename _CharT, typename _Traits>

void std::basic_streambuf< _CharT, _Traits >::gbump | ( | int | __n | ) |
| inlineprotectedinherited

Moving the read position.

Parameters

  __n | The delta by which to move.

This just advances the read position without returning any data.

Definition at line 507 of file streambuf.

Referenced by std::basic_filebuf< _CharT, _Traits >::pbackfail(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::pbackfail(), std::basic_streambuf< char_type, traits_type >::sbumpc(), std::basic_streambuf< char_type, traits_type >::sputbackc(), std::basic_streambuf< char_type, traits_type >::sungetc(), std::basic_streambuf< char_type, traits_type >::uflow(), and std::basic_filebuf< _CharT, _Traits >::xsgetn().

## ◆ getloc()

template<typename _CharT, typename _Traits>

locale std::basic_streambuf< _CharT, _Traits >::getloc | ( |  | ) | const
| inlineinherited

Locale access.

Returns
  The current locale in effect.

If pubimbue(loc) has been called, then the most recent `loc` is returned. Otherwise the global locale in effect at the time of construction is returned.

Definition at line 235 of file streambuf.

Referenced by std::basic_streambuf< char_type, traits_type >::pubimbue().

## ◆ gptr()

template<typename _CharT, typename _Traits>

char_type * std::basic_streambuf< _CharT, _Traits >::gptr | ( |  | ) | const
| inlineprotectedinherited

Access to the get area.

These functions are only available to other protected functions, including derived classes.

- eback() returns the beginning pointer for the input sequence
- gptr() returns the next pointer for the input sequence
- egptr() returns the end pointer for the input sequence

Definition at line 494 of file streambuf.

Referenced by std::basic_filebuf< char_type, traits_type >::_M_create_pback(), std::basic_filebuf< char_type, traits_type >::_M_destroy_pback(), std::basic_filebuf< _CharT, _Traits >::imbue(), std::basic_streambuf< char_type, traits_type >::in_avail(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_filebuf< _CharT, _Traits >::pbackfail(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::pbackfail(), std::basic_streambuf< char_type, traits_type >::sbumpc(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_streambuf< char_type, traits_type >::sgetc(), std::basic_filebuf< _CharT, _Traits >::showmanyc(), std::basic_stringbuf< char >::showmanyc(), std::basic_streambuf< char_type, traits_type >::sputbackc(), std::basic_streambuf< char_type, traits_type >::sungetc(), std::basic_streambuf< char_type, traits_type >::uflow(), std::basic_filebuf< _CharT, _Traits >::underflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::underflow(), std::wbuffer_convert< _Codecvt, _Elem, _Tr >::underflow(), std::basic_filebuf< _CharT, _Traits >::xsgetn(), and xsgetn().

## ◆ imbue()

template<typename _CharT, typename _Traits>

void std::basic_filebuf< _CharT, _Traits >::imbue | ( | const locale & | __loc | ) |
| protectedvirtualinherited

Changes translations.

Parameters

  __loc | A new locale.

Translations done during I/O which depend on the current locale are changed by this call. The standard adds, Between invocations of this function a class derived from streambuf can safely cache results of calls to locale functions and to members of facets so obtained.

Note
  Base class version does nothing.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 1030 of file fstream.tcc.

References _M_ext_buf, _M_ext_next, _M_mode, _M_reading, _M_set_buffer(), std::ios_base::cur, std::basic_streambuf< _CharT, _Traits >::eback(), std::basic_streambuf< _CharT, _Traits >::gptr(), is_open(), and seekoff().

## ◆ in_avail()

template<typename _CharT, typename _Traits>

streamsize std::basic_streambuf< _CharT, _Traits >::in_avail | ( |  | ) |
| inlineinherited

Looking ahead into the stream.

Returns
  The number of characters available.

If a read position is available, returns the number of characters available for reading before the buffer must be refilled. Otherwise returns the derived `showmanyc()`.

Definition at line 293 of file streambuf.

## ◆ is_open()

template<typename _CharT, typename _Traits>

bool std::basic_filebuf< _CharT, _Traits >::is_open | ( |  | ) | const
throw | ( | ) |  |  |
| inlinenodiscardinherited

Returns true if the external file is open.

Definition at line 278 of file fstream.

Referenced by __gnu_cxx::stdio_filebuf< _CharT, _Traits >::stdio_filebuf(), __gnu_cxx::stdio_filebuf< _CharT, _Traits >::stdio_filebuf(), close(), imbue(), open(), seekoff(), seekpos(), setbuf(), and showmanyc().

## ◆ open() [1/3]

template<typename _CharT, typename _Traits>
template<typename _Path>

_If_fs_path< _Path, __filebuf_type * > std::basic_filebuf< _CharT, _Traits >::open | ( | const _Path & | __s,
|  | ios_base::openmode | __mode )
| inlineinherited

Opens an external file.

Parameters

  __s | The name of the file, as a filesystem::path.
  __mode | The open mode flags.

Returns
  `this` on success, NULL on failure

Definition at line 356 of file fstream.

## ◆ open() [2/3]

template<typename _CharT, typename _Traits>

basic_filebuf< _CharT, _Traits >::__filebuf_type * std::basic_filebuf< _CharT, _Traits >::open | ( | const char * | __s,
|  | ios_base::openmode | __mode )
| inherited

Opens an external file.

Parameters

  __s | The name of the file.
  __mode | The open mode flags.

Returns
  `this` on success, NULL on failure

If a file is already open, this function immediately fails. Otherwise it tries to open the file named __s using the flags given in __mode.

Table 92, adapted here, gives the relation between openmode combinations and the equivalent `fopen()` flags. (NB: lines app, in|out|app, in|app, binary|app, binary|in|out|app, and binary|in|app per DR 596)

    +---------------------------------------------------------+
    | ios_base Flag combination            stdio equivalent   |
    |binary  in  out  trunc  app                              |
    +---------------------------------------------------------+
    |             +                        w                  |
    |             +           +            a                  |
    |                         +            a                  |
    |             +     +                  w                  |
    |         +                            r                  |
    |         +   +                        r+                 |
    |         +   +     +                  w+                 |
    |         +   +           +            a+                 |
    |         +               +            a+                 |
    +---------------------------------------------------------+
    |   +         +                        wb                 |
    |   +         +           +            ab                 |
    |   +                     +            ab                 |
    |   +         +     +                  wb                 |
    |   +     +                            rb                 |
    |   +     +   +                        r+b                |
    |   +     +   +     +                  w+b                |
    |   +     +   +           +            a+b                |
    |   +     +               +            a+b                |
    +---------------------------------------------------------+

Definition at line 183 of file fstream.tcc.

References _M_mode, _M_reading, _M_set_buffer(), std::ios_base::ate, close(), std::ios_base::end, is_open(), and seekoff().

Referenced by std::basic_filebuf< char_type, traits_type >::open(), and std::basic_filebuf< char_type, traits_type >::open().

## ◆ open() [3/3]

template<typename _CharT, typename _Traits>

__filebuf_type * std::basic_filebuf< _CharT, _Traits >::open | ( | const std::string & | __s,
|  | ios_base::openmode | __mode )
| inlineinherited

Opens an external file.

Parameters

  __s | The name of the file.
  __mode | The open mode flags.

Returns
  `this` on success, NULL on failure

Definition at line 344 of file fstream.

## ◆ overflow()

template<typename _CharT, typename _Traits>

basic_filebuf< _CharT, _Traits >::int_type std::basic_filebuf< _CharT, _Traits >::overflow | ( | int_type | __c = _Traits::eof() | ) |
| protectedvirtualinherited

Consumes data from the buffer; writes to the controlled sequence.

Parameters

  __c | An additional character to consume.

Returns
  eof() to indicate failure, something else (usually __c, or not_eof())

Informally, this function is called when the output buffer is full (or does not exist, as buffering need not actually be done). If a buffer exists, it is consumed, with some effect on the controlled sequence. (Typically, the buffer is written out to the sequence verbatim.) In either case, the character c is also written out, if __c is not `eof()`.

For a formal definition of this function, see a good text such as Langer & Kreft, or [27.5.2.4.5]/3-7.

A functioning output streambuf can be created by overriding only this function (no buffer area will be used).

Note
  Base class version does nothing, returns eof().

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 545 of file fstream.tcc.

References _M_buf_size, _M_destroy_pback(), _M_mode, _M_reading, _M_set_buffer(), std::ios_base::app, std::ios_base::cur, std::ios_base::out, std::basic_streambuf< _CharT, _Traits >::pbase(), std::basic_streambuf< _CharT, _Traits >::pbump(), and std::basic_streambuf< _CharT, _Traits >::pptr().

Referenced by pbackfail(), sync(), underflow(), and xsgetn().

## ◆ pbackfail()

template<typename _CharT, typename _Traits>

basic_filebuf< _CharT, _Traits >::int_type std::basic_filebuf< _CharT, _Traits >::pbackfail | ( | int_type | __c = _Traits::eof() | ) |
| protectedvirtualinherited

Tries to back up the input sequence.

Parameters

  __c | The character to be inserted back into the sequence.

Returns
  eof() on failure, some other value on success

Postcondition
  The constraints of `gptr()`, `eback()`, and `pptr()` are the same as for `underflow()`.

Note
  Base class version does nothing, returns eof().

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 486 of file fstream.tcc.

References _M_create_pback(), _M_mode, _M_pback_init, _M_reading, _M_set_buffer(), std::ios_base::cur, std::basic_streambuf< _CharT, _Traits >::eback(), std::basic_streambuf< _CharT, _Traits >::gbump(), std::basic_streambuf< _CharT, _Traits >::gptr(), std::ios_base::in, overflow(), seekoff(), and underflow().

## ◆ pbase()

template<typename _CharT, typename _Traits>

char_type * std::basic_streambuf< _CharT, _Traits >::pbase | ( |  | ) | const
| inlineprotectedinherited

Access to the put area.

These functions are only available to other protected functions, including derived classes.

- pbase() returns the beginning pointer for the output sequence
- pptr() returns the next pointer for the output sequence
- epptr() returns the end pointer for the output sequence

Definition at line 538 of file streambuf.

Referenced by std::basic_filebuf< _CharT, _Traits >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_filebuf< _CharT, _Traits >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), std::basic_stringbuf< char >::str(), std::basic_filebuf< _CharT, _Traits >::sync(), and std::basic_filebuf< _CharT, _Traits >::xsputn().

## ◆ pbump()

template<typename _CharT, typename _Traits>

void std::basic_streambuf< _CharT, _Traits >::pbump | ( | int | __n | ) |
| inlineprotectedinherited

Moving the write position.

Parameters

  __n | The delta by which to move.

This just advances the write position without returning any data.

Definition at line 554 of file streambuf.

Referenced by std::basic_filebuf< _CharT, _Traits >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), and std::basic_streambuf< char_type, traits_type >::sputc().

## ◆ pptr()

template<typename _CharT, typename _Traits>

char_type * std::basic_streambuf< _CharT, _Traits >::pptr | ( |  | ) | const
| inlineprotectedinherited

Access to the put area.

These functions are only available to other protected functions, including derived classes.

- pbase() returns the beginning pointer for the output sequence
- pptr() returns the next pointer for the output sequence
- epptr() returns the end pointer for the output sequence

Definition at line 541 of file streambuf.

Referenced by std::basic_filebuf< _CharT, _Traits >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_filebuf< _CharT, _Traits >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_streambuf< char_type, traits_type >::sputc(), std::basic_filebuf< _CharT, _Traits >::sync(), std::basic_filebuf< _CharT, _Traits >::xsputn(), and xsputn().

## ◆ pubimbue()

template<typename _CharT, typename _Traits>

locale std::basic_streambuf< _CharT, _Traits >::pubimbue | ( | const locale & | __loc | ) |
| inlineinherited

Entry point for imbue().

Parameters

  __loc | The new locale.

Returns
  The previous locale.

Calls the derived imbue(__loc).

Definition at line 218 of file streambuf.

## ◆ pubseekoff()

template<typename _CharT, typename _Traits>

pos_type std::basic_streambuf< _CharT, _Traits >::pubseekoff | ( | off_type | __off,
|  | ios_base::seekdir | __way,
|  | ios_base::openmode | __mode = ios_base::in | ios_base::out )
| inlineinherited

Alters the stream position.

Parameters

  __off | Offset.
  __way | Value for ios_base::seekdir.
  __mode | Value for ios_base::openmode.

Calls virtual seekoff function.

Definition at line 260 of file streambuf.

## ◆ pubseekpos()

template<typename _CharT, typename _Traits>

pos_type std::basic_streambuf< _CharT, _Traits >::pubseekpos | ( | pos_type | __sp,
|  | ios_base::openmode | __mode = ios_base::in | ios_base::out )
| inlineinherited

Alters the stream position.

Parameters

  __sp | Position
  __mode | Value for ios_base::openmode.

Calls virtual seekpos function.

Definition at line 272 of file streambuf.

## ◆ pubsetbuf()

template<typename _CharT, typename _Traits>

basic_streambuf * std::basic_streambuf< _CharT, _Traits >::pubsetbuf | ( | char_type * | __s,
|  | streamsize | __n )
| inlineinherited

Entry points for derived buffer functions.

The public versions of `pubfoo` dispatch to the protected derived `foo` member functions, passing the arguments (if any) and returning the result unchanged.

Definition at line 248 of file streambuf.

## ◆ pubsync()

template<typename _CharT, typename _Traits>

int std::basic_streambuf< _CharT, _Traits >::pubsync | ( |  | ) |
| inlineinherited

Calls virtual sync function.

Definition at line 280 of file streambuf.

Referenced by std::basic_istream< _CharT, _Traits >::sync().

## ◆ sbumpc()

template<typename _CharT, typename _Traits>

int_type std::basic_streambuf< _CharT, _Traits >::sbumpc | ( |  | ) |
| inlineinherited

Getting the next character.

Returns
  The next character, or eof.

If the input read position is available, returns that character and increments the read pointer, otherwise calls and returns `uflow()`.

Definition at line 325 of file streambuf.

Referenced by std::basic_istream< _CharT, _Traits >::ignore(), std::basic_streambuf< char_type, traits_type >::snextc(), and std::basic_istream< _CharT, char_traits< _CharT > >::unget().

## ◆ seekoff()

template<typename _CharT, typename _Traits>

basic_filebuf< _CharT, _Traits >::pos_type std::basic_filebuf< _CharT, _Traits >::seekoff | ( | off_type | ,
|  | ios_base::seekdir | ,
|  | ios_base::openmode | = ios_base::in | ios_base::out )
| protectedvirtualinherited

Alters the stream positions.

Each derived class provides its own appropriate behavior.

Note
  Base class version does nothing, returns a `pos_type` that represents an invalid stream position.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 833 of file fstream.tcc.

References _M_destroy_pback(), _M_reading, std::ios_base::cur, is_open(), std::basic_streambuf< _CharT, _Traits >::pbase(), and std::basic_streambuf< _CharT, _Traits >::pptr().

Referenced by imbue(), open(), and pbackfail().

## ◆ seekpos()

template<typename _CharT, typename _Traits>

basic_filebuf< _CharT, _Traits >::pos_type std::basic_filebuf< _CharT, _Traits >::seekpos | ( | pos_type | ,
|  | ios_base::openmode | = ios_base::in | ios_base::out )
| protectedvirtualinherited

Alters the stream positions.

Each derived class provides its own appropriate behavior.

Note
  Base class version does nothing, returns a `pos_type` that represents an invalid stream position.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 893 of file fstream.tcc.

References _M_destroy_pback(), std::ios_base::beg, and is_open().

## ◆ setbuf()

template<typename _CharT, typename _Traits>

basic_filebuf< _CharT, _Traits >::__streambuf_type * std::basic_filebuf< _CharT, _Traits >::setbuf | ( | char_type * | __s,
|  | streamsize | __n )
| protectedvirtualinherited

Manipulates the buffer.

Parameters

  __s | Pointer to a buffer area.
  __n | Size of __s.

Returns
  `this`

If no file has been opened, and both __s and __n are zero, then the stream becomes unbuffered. Otherwise, `__s` is used as a buffer; see https://gcc.gnu.org/onlinedocs/libstdc++/manual/streambufs.html#io.streambuf.buffering for more.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 804 of file fstream.tcc.

References _M_buf, _M_buf_size, and is_open().

## ◆ setg()

template<typename _CharT, typename _Traits>

void std::basic_streambuf< _CharT, _Traits >::setg | ( | char_type * | __gbeg,
|  | char_type * | __gnext,
|  | char_type * | __gend )
| inlineprotectedinherited

Setting the three read area pointers.

Parameters

  __gbeg | A pointer.
  __gnext | A pointer.
  __gend | A pointer.

Postcondition
  __gbeg == `eback()`, __gnext == `gptr()`, and __gend == `egptr()`

Definition at line 518 of file streambuf.

Referenced by std::wbuffer_convert< _Codecvt, _Elem, _Tr >::wbuffer_convert(), std::basic_filebuf< char_type, traits_type >::_M_create_pback(), std::basic_filebuf< char_type, traits_type >::_M_destroy_pback(), std::basic_filebuf< char_type, traits_type >::_M_set_buffer(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), and std::basic_filebuf< _CharT, _Traits >::xsgetn().

## ◆ setp()

template<typename _CharT, typename _Traits>

void std::basic_streambuf< _CharT, _Traits >::setp | ( | char_type * | __pbeg,
|  | char_type * | __pend )
| inlineprotectedinherited

Setting the three write area pointers.

Parameters

  __pbeg | A pointer.
  __pend | A pointer.

Postcondition
  __pbeg == `pbase()`, __pbeg == `pptr()`, and __pend == `epptr()`

Definition at line 564 of file streambuf.

Referenced by std::wbuffer_convert< _Codecvt, _Elem, _Tr >::wbuffer_convert(), and std::basic_filebuf< char_type, traits_type >::_M_set_buffer().

## ◆ sgetc()

template<typename _CharT, typename _Traits>

int_type std::basic_streambuf< _CharT, _Traits >::sgetc | ( |  | ) |
| inlineinherited

Getting the next character.

Returns
  The next character, or eof.

If the input read position is available, returns that character, otherwise calls and returns `underflow()`. Does not move the read position after fetching the character.

Definition at line 347 of file streambuf.

Referenced by std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_istream< _CharT, char_traits< _CharT > >::readsome(), and std::basic_streambuf< char_type, traits_type >::snextc().

## ◆ sgetn()

template<typename _CharT, typename _Traits>

streamsize std::basic_streambuf< _CharT, _Traits >::sgetn | ( | char_type * | __s,
|  | streamsize | __n )
| inlineinherited

Entry point for xsgetn.

Parameters

  __s | A buffer area.
  __n | A count.

Returns xsgetn(__s,__n). The effect is to fill __s[0] through __s[__n-1] with characters from the input sequence, if possible.

Definition at line 366 of file streambuf.

## ◆ showmanyc()

template<typename _CharT, typename _Traits>

streamsize std::basic_filebuf< _CharT, _Traits >::showmanyc | ( |  | ) |
| protectedvirtualinherited

Investigating the data available.

Returns
  An estimate of the number of characters available in the input sequence, or -1.

If it returns a positive value, then successive calls to `underflow()` will not return `traits::eof()` until at least that number of characters have been supplied. If `showmanyc()` returns -1, then calls to `underflow()` or `uflow()` will fail. [27.5.2.4.3]/1

Note
  Base class version does nothing, returns zero.
  The standard adds that the intention is not only that the calls [to underflow or uflow] will not return `eof()` but that they will return immediately.
  The standard adds that the morphemes of `showmanyc` are es-how-many-see, not show-manic.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 301 of file fstream.tcc.

References _M_mode, std::ios_base::binary, std::basic_streambuf< _CharT, _Traits >::egptr(), std::basic_streambuf< _CharT, _Traits >::gptr(), std::ios_base::in, and is_open().

## ◆ snextc()

template<typename _CharT, typename _Traits>

int_type std::basic_streambuf< _CharT, _Traits >::snextc | ( |  | ) |
| inlineinherited

Getting the next character.

Returns
  The next character, or eof.

Calls `sbumpc()`, and if that function returns `traits::eof()`, so does this function. Otherwise, `sgetc()`.

Definition at line 307 of file streambuf.

Referenced by std::basic_istream< _CharT, char_traits< _CharT > >::get(), std::basic_iostream< char_type, traits_type >::ignore(), and std::basic_istream< _CharT, char_traits< _CharT > >::readsome().

## ◆ sputbackc()

template<typename _CharT, typename _Traits>

int_type std::basic_streambuf< _CharT, _Traits >::sputbackc | ( | char_type | __c | ) |
| inlineinherited

Pushing characters back into the input stream.

Parameters

  __c | The character to push back.

Returns
  The previous character, if possible.

Similar to sungetc(), but __c is pushed onto the stream instead of the previous character. If successful, the next character fetched from the input stream will be __c.

Definition at line 381 of file streambuf.

Referenced by std::basic_istream< _CharT, _Traits >::putback().

## ◆ sputc()

template<typename _CharT, typename _Traits>

int_type std::basic_streambuf< _CharT, _Traits >::sputc | ( | char_type | __c | ) |
| inlineinherited

Entry point for all single-character output functions.

Parameters

  __c | A character to output.

Returns
  __c, if possible.

One of two public output functions.

If a write position is available for the output sequence (i.e., the buffer is not full), stores __c in that position, increments the position, and returns `traits::to_int_type(__c)`. If a write position is not available, returns `overflow(__c)`.

Definition at line 433 of file streambuf.

Referenced by std::wbuffer_convert< _Codecvt, _Elem, _Tr >::overflow().

## ◆ sputn()

template<typename _CharT, typename _Traits>

streamsize std::basic_streambuf< _CharT, _Traits >::sputn | ( | const char_type * | __s,
|  | streamsize | __n )
| inlineinherited

Entry point for all single-character output functions.

Parameters

  __s | A buffer read area.
  __n | A count.

One of two public output functions.

Returns xsputn(__s,__n). The effect is to write __s[0] through __s[__n-1] to the output sequence, if possible.

Definition at line 459 of file streambuf.

## ◆ sungetc()

template<typename _CharT, typename _Traits>

int_type std::basic_streambuf< _CharT, _Traits >::sungetc | ( |  | ) |
| inlineinherited

Moving backwards in the input stream.

Returns
  The previous character, if possible.

If a putback position is available, this function decrements the input pointer and returns that character. Otherwise, calls and returns pbackfail(). The effect is to unget the last character gotten.

Definition at line 406 of file streambuf.

Referenced by std::basic_istream< _CharT, _Traits >::unget().

## ◆ swap() [1/3]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

void __gnu_cxx::stdio_filebuf< _CharT, _Traits >::swap | ( | stdio_filebuf< _CharT, _Traits > & | __fb | ) |
| inline

Definition at line 109 of file stdio_filebuf.h.

## ◆ swap() [2/3]

template<typename _CharT, typename _Traits>

void std::basic_filebuf< _CharT, _Traits >::swap | ( | basic_filebuf< _CharT, _Traits > & | __rhs | ) |
| inherited

Definition at line 157 of file fstream.tcc.

## ◆ swap() [3/3]

template<typename _CharT, typename _Traits>

void std::basic_streambuf< _CharT, _Traits >::swap | ( | basic_streambuf< _CharT, _Traits > & | __sb | ) |
| inlineprotectedinherited

Definition at line 821 of file streambuf.

## ◆ sync()

template<typename _CharT, typename _Traits>

int std::basic_filebuf< _CharT, _Traits >::sync | ( |  | ) |
| protectedvirtualinherited

Synchronizes the buffer arrays with the controlled sequences.

Returns
  -1 on failure.

Each derived class provides its own appropriate behavior, including the definition of failure.

Note
  Base class version does nothing, returns zero.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 1013 of file fstream.tcc.

References overflow(), std::basic_streambuf< _CharT, _Traits >::pbase(), and std::basic_streambuf< _CharT, _Traits >::pptr().

## ◆ uflow()

template<typename _CharT, typename _Traits>

virtual int_type std::basic_streambuf< _CharT, _Traits >::uflow | ( |  | ) |
| inlineprotectedvirtualinherited

Fetches more data from the controlled sequence.

Returns
  The first character from the pending sequence.

Informally, this function does the same thing as `underflow()`, and in fact is required to call that function. It also returns the new character, like `underflow()` does. However, this function also moves the read position forward by one.

Reimplemented in __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >.

Definition at line 709 of file streambuf.

Referenced by std::basic_streambuf< char_type, traits_type >::sbumpc(), and xsgetn().

## ◆ underflow()

template<typename _CharT, typename _Traits>

basic_filebuf< _CharT, _Traits >::int_type std::basic_filebuf< _CharT, _Traits >::underflow | ( |  | ) |
| protectedvirtualinherited

Fetches more data from the controlled sequence.

Returns
  The first character from the pending sequence.

Informally, this function is called when the input buffer is exhausted (or does not exist, as buffering need not actually be done). If a buffer exists, it is refilled. In either case, the next available character is returned, or `traits::eof()` to indicate a null pending sequence.

For a formal definition of the pending sequence, see a good text such as Langer & Kreft, or [27.5.2.4.3]/7-14.

A functioning input streambuf can be created by overriding only this function (no buffer area will be used). For an example, see https://gcc.gnu.org/onlinedocs/libstdc++/manual/streambufs.html

Note
  Base class version does nothing, returns eof().

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 327 of file fstream.tcc.

References _M_buf_size, _M_destroy_pback(), _M_mode, _M_set_buffer(), std::basic_streambuf< _CharT, _Traits >::eback(), std::basic_streambuf< _CharT, _Traits >::egptr(), std::basic_streambuf< _CharT, _Traits >::gptr(), std::ios_base::in, and overflow().

Referenced by pbackfail().

## ◆ xsgetn()

template<typename _CharT, typename _Traits>

streamsize std::basic_filebuf< _CharT, _Traits >::xsgetn | ( | char_type * | __s,
|  | streamsize | __n )
| protectedvirtualinherited

Multiple character extraction.

Parameters

  __s | A buffer area.
  __n | Maximum number of characters to assign.

Returns
  The number of characters assigned.

Fills __s[0] through __s[__n-1] with characters from the input sequence, as if by `sbumpc()`. Stops when either __n characters have been copied, or when `traits::eof()` would be copied.

It is expected that derived classes provide a more efficient implementation by overriding this definition.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 673 of file fstream.tcc.

References _M_buf_size, _M_destroy_pback(), _M_mode, _M_pback_init, _M_reading, _M_set_buffer(), std::basic_streambuf< _CharT, _Traits >::eback(), std::basic_streambuf< _CharT, _Traits >::egptr(), std::basic_streambuf< _CharT, _Traits >::gbump(), std::basic_streambuf< _CharT, _Traits >::gptr(), std::ios_base::in, overflow(), std::basic_streambuf< _CharT, _Traits >::setg(), and std::basic_streambuf< char_type, traits_type >::xsgetn().

## ◆ xsputn()

template<typename _CharT, typename _Traits>

streamsize std::basic_filebuf< _CharT, _Traits >::xsputn | ( | const char_type * | __s,
|  | streamsize | __n )
| protectedvirtualinherited

Multiple character insertion.

Parameters

  __s | A buffer area.
  __n | Maximum number of characters to write.

Returns
  The number of characters written.

Writes __s[0] through __s[__n-1] to the output sequence, as if by `sputc()`. Stops when either n characters have been copied, or when `sputc()` would return `traits::eof()`.

It is expected that derived classes provide a more efficient implementation by overriding this definition.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 759 of file fstream.tcc.

References _M_buf_size, _M_mode, _M_reading, _M_set_buffer(), std::ios_base::app, std::basic_streambuf< _CharT, _Traits >::epptr(), std::ios_base::out, std::basic_streambuf< _CharT, _Traits >::pbase(), std::basic_streambuf< _CharT, _Traits >::pptr(), and std::basic_streambuf< char_type, traits_type >::xsputn().

## Member Data Documentation

## ◆ _M_buf

template<typename _CharT, typename _Traits>

char_type* std::basic_filebuf< _CharT, _Traits >::_M_buf
| protectedinherited

Pointer to the beginning of internal buffer.

Definition at line 148 of file fstream.

Referenced by basic_filebuf(), and setbuf().

## ◆ _M_buf_allocated

template<typename _CharT, typename _Traits>

bool std::basic_filebuf< _CharT, _Traits >::_M_buf_allocated
| protectedinherited

Definition at line 158 of file fstream.

## ◆ _M_buf_locale

template<typename _CharT, typename _Traits>

locale std::basic_streambuf< _CharT, _Traits >::_M_buf_locale
| protectedinherited

Current locale setting.

Definition at line 201 of file streambuf.

Referenced by std::basic_filebuf< _CharT, _Traits >::basic_filebuf().

## ◆ _M_buf_size

template<typename _CharT, typename _Traits>

size_t std::basic_filebuf< _CharT, _Traits >::_M_buf_size
| protectedinherited

Actual size of internal buffer. This number is equal to the size of the put area + 1 position, reserved for the overflow char of a full area.

Definition at line 155 of file fstream.

Referenced by basic_filebuf(), __gnu_cxx::stdio_filebuf< _CharT, _Traits >::stdio_filebuf(), __gnu_cxx::stdio_filebuf< _CharT, _Traits >::stdio_filebuf(), overflow(), setbuf(), underflow(), xsgetn(), and xsputn().

## ◆ _M_codecvt

template<typename _CharT, typename _Traits>

const __codecvt_type* std::basic_filebuf< _CharT, _Traits >::_M_codecvt
| protectedinherited

Definition at line 183 of file fstream.

## ◆ _M_ext_buf

template<typename _CharT, typename _Traits>

char* std::basic_filebuf< _CharT, _Traits >::_M_ext_buf
| protectedinherited

Buffer for external characters. Used for input when codecvt::always_noconv() == false. When valid, this corresponds to eback().

Definition at line 190 of file fstream.

Referenced by basic_filebuf(), and imbue().

## ◆ _M_ext_buf_size

template<typename _CharT, typename _Traits>

streamsize std::basic_filebuf< _CharT, _Traits >::_M_ext_buf_size
| protectedinherited

Size of buffer held by _M_ext_buf.

Definition at line 195 of file fstream.

Referenced by basic_filebuf().

## ◆ _M_ext_end

template<typename _CharT, typename _Traits>

char* std::basic_filebuf< _CharT, _Traits >::_M_ext_end
| protectedinherited

Definition at line 203 of file fstream.

## ◆ _M_ext_next

template<typename _CharT, typename _Traits>

const char* std::basic_filebuf< _CharT, _Traits >::_M_ext_next
| protectedinherited

Pointers into the buffer held by _M_ext_buf that delimit a subsequence of bytes that have been read but not yet converted. When valid, _M_ext_next corresponds to egptr().

Definition at line 202 of file fstream.

Referenced by basic_filebuf(), and imbue().

## ◆ _M_file

template<typename _CharT, typename _Traits>

__file_type std::basic_filebuf< _CharT, _Traits >::_M_file
| protectedinherited

Definition at line 130 of file fstream.

## ◆ _M_in_beg

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::_M_in_beg
| protectedinherited

Start of get area.

Definition at line 193 of file streambuf.

## ◆ _M_in_cur

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::_M_in_cur
| protectedinherited

Current read area.

Definition at line 194 of file streambuf.

## ◆ _M_in_end

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::_M_in_end
| protectedinherited

End of get area.

Definition at line 195 of file streambuf.

## ◆ _M_lock

template<typename _CharT, typename _Traits>

__c_lock std::basic_filebuf< _CharT, _Traits >::_M_lock
| protectedinherited

Definition at line 127 of file fstream.

## ◆ _M_mode

template<typename _CharT, typename _Traits>

ios_base::openmode std::basic_filebuf< _CharT, _Traits >::_M_mode
| protectedinherited

Place to stash in || out || in | out settings for current filebuf.

Definition at line 133 of file fstream.

Referenced by basic_filebuf(), __gnu_cxx::stdio_filebuf< _CharT, _Traits >::stdio_filebuf(), __gnu_cxx::stdio_filebuf< _CharT, _Traits >::stdio_filebuf(), close(), imbue(), open(), overflow(), pbackfail(), showmanyc(), underflow(), xsgetn(), and xsputn().

## ◆ _M_out_beg

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::_M_out_beg
| protectedinherited

Start of put area.

Definition at line 196 of file streambuf.

## ◆ _M_out_cur

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::_M_out_cur
| protectedinherited

Current put area.

Definition at line 197 of file streambuf.

## ◆ _M_out_end

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::_M_out_end
| protectedinherited

End of put area.

Definition at line 198 of file streambuf.

## ◆ _M_pback

template<typename _CharT, typename _Traits>

char_type std::basic_filebuf< _CharT, _Traits >::_M_pback
| protectedinherited

Necessary bits for putback buffer management.

Note
  pbacks of over one character are not currently supported.

Definition at line 176 of file fstream.

Referenced by basic_filebuf().

## ◆ _M_pback_cur_save

template<typename _CharT, typename _Traits>

char_type* std::basic_filebuf< _CharT, _Traits >::_M_pback_cur_save
| protectedinherited

Necessary bits for putback buffer management.

Note
  pbacks of over one character are not currently supported.

Definition at line 177 of file fstream.

Referenced by basic_filebuf().

## ◆ _M_pback_end_save

template<typename _CharT, typename _Traits>

char_type* std::basic_filebuf< _CharT, _Traits >::_M_pback_end_save
| protectedinherited

Necessary bits for putback buffer management.

Note
  pbacks of over one character are not currently supported.

Definition at line 178 of file fstream.

Referenced by basic_filebuf().

## ◆ _M_pback_init

template<typename _CharT, typename _Traits>

bool std::basic_filebuf< _CharT, _Traits >::_M_pback_init
| protectedinherited

Necessary bits for putback buffer management.

Note
  pbacks of over one character are not currently supported.

Definition at line 179 of file fstream.

Referenced by basic_filebuf(), close(), pbackfail(), and xsgetn().

## ◆ _M_reading

template<typename _CharT, typename _Traits>

bool std::basic_filebuf< _CharT, _Traits >::_M_reading
| protectedinherited

_M_reading == false && _M_writing == false for uncommitted mode; _M_reading == true for read mode; _M_writing == true for write mode;

NB: _M_reading == true && _M_writing == true is unused.

Definition at line 167 of file fstream.

Referenced by basic_filebuf(), __gnu_cxx::stdio_filebuf< _CharT, _Traits >::stdio_filebuf(), __gnu_cxx::stdio_filebuf< _CharT, _Traits >::stdio_filebuf(), close(), imbue(), open(), overflow(), pbackfail(), seekoff(), xsgetn(), and xsputn().

## ◆ _M_state_beg

template<typename _CharT, typename _Traits>

__state_type std::basic_filebuf< _CharT, _Traits >::_M_state_beg
| protectedinherited

Definition at line 136 of file fstream.

## ◆ _M_state_cur

template<typename _CharT, typename _Traits>

__state_type std::basic_filebuf< _CharT, _Traits >::_M_state_cur
| protectedinherited

Definition at line 141 of file fstream.

## ◆ _M_state_last

template<typename _CharT, typename _Traits>

__state_type std::basic_filebuf< _CharT, _Traits >::_M_state_last
| protectedinherited

Definition at line 145 of file fstream.

## ◆ _M_writing

template<typename _CharT, typename _Traits>

bool std::basic_filebuf< _CharT, _Traits >::_M_writing
| protectedinherited

Definition at line 168 of file fstream.

The documentation for this class was generated from the following file:

- stdio_filebuf.h